this.name	 = "System Features: DS Corona";
this.author      = "rustem"; 
this.copyright	 = "March 2016";
this.licence 	 = "CC-BY-SA 4.0";
this.version     = "0.2"; 
this.description = "Populator script for the sun features";

"use strict";

//Based on System_Features_Sunspots
//develop -cim-, edit -rustem-

this.startUp = function() {
		this.$overrides = [[],[],[],[],[],[],[],[]];
		delete this.startUp;
		this.logging = true; // Must be false for release		
}

this._clearFeatures = function() {
		//for clearing overrides
		//this.setFeatures = false;
		System.infoForSystem(galaxyNumber, system.ID).corona_flare = 0;
		//System.infoForSystem(galaxyNumber, system.ID).corona_flare = null;// value = 1
		//System.infoForSystem(galaxyNumber, system.ID).setProperty(2, "corona_flare", -1);
		if(this.logging) log(this.name,'Reset solar activity');
		return;
}

this.systemWillPopulate = function() {
	system.setPopulator("system_features_sun",
						{
							callback: this._addFeatures.bind(this),
							priority: 1000
						});
}

this._addFeatures = function() {
		if (this.$overrides[galaxyNumber].indexOf(system.ID) > -1) {
				return;
		} 
		if (!system.sun) {
				return;
		}

		// make the solar flare

		this.setFeatures = false;

		var addflare = 0;
		var rndflare = Math.random()*10;
		var muxflare = Math.random()*1;
		// ver.1 - read from layer 2
		var corflare = system.info.corona_flare;
		if(this.logging) log(this.name,'Default corona flare is:'+corflare);

		if (system.info.description.indexOf("solar activity") > -1) {
				// ver.2 - temp generation version
				//var corflare = 0.01 + Math.random()*0.09;
				if (system.info.sun_name.indexOf("Star") > -1 ) {
						if (system.info.sun_name.indexOf("A2") > -1 ) {
							corflare = 0.24 + Math.random()*0.08;
							if(this.logging) log(this.name,'Set A2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("A7") > -1 ) {
							corflare = 0.12 + Math.random()*0.06;
							if(this.logging) log(this.name,'Set A7 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("F2") > -1 ) {
							corflare = 0.08 + Math.random()*0.06;
							if(this.logging) log(this.name,'Set F2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("G2") > -1 ) {
							corflare = 0.06 + Math.random()*0.04;
							if(this.logging) log(this.name,'Set G2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("K2") > -1 ) {
							corflare = 0.05 + Math.random()*0.03;
							if(this.logging) log(this.name,'Set K2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("K8") > -1 ) {
							corflare = 0.03 + Math.random()*0.03;
							if(this.logging) log(this.name,'Set K8 corona flare is:'+corflare);
						}
				} else if(this.logging) log(this.name,'No star name!');
				addflare += corflare*0.5;
				rndflare *= 1.5;
				if (system.info.description.indexOf("frequent solar activity") > -1) {
						//rndflare += 3;
						addflare += 0.025;
				} else if (system.info.description.indexOf("dreadful solar activity") > -1 || system.info.description.indexOf("deadly solar activity") > -1) {
						//rndflare *= 1.5;
						addflare += 0.15;
				} else if (system.info.description.indexOf("unpredictable solar activity") > -1 ) {
						//rndflare += 1.5;
						rndflare = Math.floor(rndflare-4.5);
						if (rndflare < 1) rndflare = 0;
						rndflare *= muxflare*0.015;
						addflare += rndflare;
						if(this.logging) log(this.name,'Add unpredictable value:'+rndflare);
				}
				corflare += addflare;
				System.infoForSystem(galaxyNumber, system.ID).corona_flare = corflare;
				this.setFeatures = true;
				if(this.logging) log(this.name,'Add solar activity. Final corona flare is:'+corflare);
		}

		//Set to distant star value
		if (corflare === 0) {
				if (system.info.sun_name.indexOf("Star") > -1 ) {
						if (system.info.sun_name.indexOf("A2") > -1 ) {
							corflare = 0.24 + Math.random()*0.08;
							if(this.logging) log(this.name,'Set A2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("A7") > -1 ) {
							corflare = 0.12 + Math.random()*0.06;
							if(this.logging) log(this.name,'Set A7 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("F2") > -1 ) {
							corflare = 0.08 + Math.random()*0.06;
							if(this.logging) log(this.name,'Set F2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("G2") > -1 ) {
							corflare = 0.06 + Math.random()*0.04;
							if(this.logging) log(this.name,'Set G2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("K2") > -1 ) {
							corflare = 0.05 + Math.random()*0.03;
							if(this.logging) log(this.name,'Set K2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("K8") > -1 ) {
							corflare = 0.03 + Math.random()*0.03;
							if(this.logging) log(this.name,'Set K8 corona flare is:'+corflare);
						}
				} else if(this.logging) log(this.name,'No star name!');
				System.infoForSystem(galaxyNumber, system.ID).corona_flare = corflare;
				if(this.logging) log(this.name,'Set to distant star value. Final corona flare is:'+corflare);
		}

}

this.shipWillEnterWitchspace = function(cause)
{
	this._resetFeatures();
}

this._resetFeatures = function()
{
	if (this.setFeatures) this._clearFeatures();
	return;
}
